
#ifndef EQ_H
#define EQ_H


#include "readData.h"
#include "generalization.h"
#include "fullSpace.h"
//#include "topDown.h"

struct equivalenceTuple_s
{
	dimension *content;
	int noOfMember;
	int noOfSen;
	int *member;
	int *isSen;

	// newly added
	int id;
};
typedef struct equivalenceTuple_s equivalenceTuple;

struct equivalenceClass_s
{
	int noOfEqClass;
	equivalenceTuple **eqClass;
};
typedef struct equivalenceClass_s equivalenceClass;

extern FILE *g_debugFilePtr;


int ceiling(double no);
void progressiveMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);
int isAlphaKAnonymity_EquivalenceClass(equivalenceTuple *eqOne, configure *conf);

extern double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable);
extern double calculateSenDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable);
extern int calculateGreatestPossRemovalCount(equivalenceClass *eqClass, configure *conf);
extern int chooseBestAttribute(equivalenceClass *eqClass, data *dataSet, configure *conf);
extern void generalizeEqClass(equivalenceClass *eqClass, int attrNo, configure *conf, generalizedAllTable *genAllTable);

float calculateDistanceBetweenEquivalenceTuple(configure *conf, generalizedAllTable *genAllTable, equivalenceTuple *eqTuple1, equivalenceTuple *eqTuple2);

void insertEqTupleIntoEqClass(equivalenceClass *eqClass, equivalenceTuple *eqTuple);
void removeEqTupleFromEqClass(equivalenceClass *eqClass, int index);

void mergeEqClass(equivalenceClass *eqClass, data *dataSet, configure *conf);

equivalenceTuple *mergeTwoEquivalenceTuple(int noOfDim, generalizedAllTable *genAllTable, equivalenceTuple *eqTuple1, equivalenceTuple *eqTuple2);

void hierachicalMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);
void randomMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);
void fullSpaceMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);
void topDownAlphaMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);

equivalenceClass *cloneEquivalenceClass(equivalenceClass *eqClass, configure *conf);
equivalenceClass *cloneEquivalenceClassWithProjection(equivalenceClass *eqClass, int noOfDim, AttributeList *attrList, data *dataSet, configure *conf);
void freeEquivalenceClass(equivalenceClass *eqClass);

void printEquivalenceClass(FILE *filePtr, equivalenceClass *eqClass, int noOfDim);

int findMin(int no1, int no2);

equivalenceTuple *cloneEquivalenceTuple(equivalenceTuple *eqTuple, configure *conf);

extern double *checkAllGenDomainSet(AllGeneralizationDomainSet *allGenDomainSet, equivalenceClass *eqClass, configure *conf, data *dataSet, generalizedAllTable *genAllTable, int isCalculate);
extern equivalenceClass *chooseBestFinalEqClass(AllGeneralizationDomainSet *allGenDomainSet, double *dist, equivalenceClass *eqClass, data *dataSet, configure *conf, generalizedAllTable *genAllTable);

extern equivalenceClass *top_generalize2TopLevel(data *dataSet, generalizedAllTable *genAllTable);
//extern equivalenceTuple ****top_generateAllExpandValidEqTuple(equivalenceClass *eqClass, configure *conf, data *dataSet, generalizedAllTable *genAllTable, int ***noOfChild, int ****isSatisfy);

extern equivalenceTuple ****top_generateAllExpandValidEqTuple(equivalenceTuple ***parentEqTuple, int noOfParent, configure *conf, data *dataSet, generalizedAllTable *genAllTable, int ***noOfChild, int ****isSatisfy);
extern void top_processBestAttribute(equivalenceClass *finalEqClass, equivalenceClass *procEqClass, int noOfParentEqTuple, equivalenceTuple ***parentEqTuple, equivalenceTuple ****childEqTuple, int **noOfChild, int ***isSatisfy, configure *conf);

void freeEquivalenceTuple(equivalenceTuple *eqTuple);

#endif
