
#include "topDown.h"

void top_removeMemberSen_One(equivalenceTuple *eqTuple, int index, int *memberNo, int *isSen)
{
	int noOfMember;

	int *newMember;
	int *newIsSen;

	int *oldMember;
	int *oldIsSen;

	noOfMember = eqTuple->noOfMember;

	oldMember = eqTuple->member;
	oldIsSen = eqTuple->isSen;

	(*memberNo) = eqTuple->member[index];
	(*isSen) = eqTuple->isSen[index];

	if (noOfMember == 1)
	{
		newMember = NULL;
		newIsSen = NULL;
	}
	else
	{
		newMember = (int *) malloc(sizeof(int)*(noOfMember-1));
		newIsSen = (int *) malloc(sizeof(int)*(noOfMember-1));

		if (index > 0)
		{
			memcpy(newMember, oldMember, sizeof(int)*index);
			memcpy(newIsSen, oldIsSen, sizeof(int)*index);
		}

		if (index < noOfMember-1)
		{
			memcpy(&(newMember[index]), &(oldMember[index+1]), sizeof(int)*(noOfMember-index-1));
			memcpy(&(newIsSen[index]), &(oldIsSen[index+1]), sizeof(int)*(noOfMember-index-1));
		}
	}

	// assign
	eqTuple->member = newMember;
	eqTuple->isSen = newIsSen;

	eqTuple->noOfMember--;
	if ((*isSen) == 1)
	{
		eqTuple->noOfSen--;
	}

	// free
	free(oldMember);
	free(oldIsSen);
	
}

void top_removeMemberSen_All(equivalenceTuple *eqTuple, int **member, int **isSen, int *noOfMember, int *noOfSen)
{
	(*member) = eqTuple->member;
	(*isSen) = eqTuple->isSen;
	(*noOfMember) = eqTuple->noOfMember;
	(*noOfSen) = eqTuple->noOfSen;
}


void top_insertMemberSen_One(equivalenceTuple *eqTuple, int memberNo, int isSen)
{
	int noOfMember;

	int *newMember;
	int *newIsSen;

	noOfMember = eqTuple->noOfMember;

	if (noOfMember > 0)
	{
		newMember = (int *) realloc(eqTuple->member, sizeof(int)*(noOfMember+1));
		newIsSen = (int *) realloc(eqTuple->isSen, sizeof(int)*(noOfMember+1));
	}
	else
	{
		newMember = (int *) malloc(sizeof(int));
		newIsSen = (int *) malloc(sizeof(int));
	}

	newMember[noOfMember] = memberNo;
	newIsSen[noOfMember] = isSen;

	eqTuple->member = newMember;
	eqTuple->isSen = newIsSen;

	eqTuple->noOfMember++;
	if (isSen == 1)
	{
		eqTuple->noOfSen++;
	}
}

void top_insertMemberSen_All(equivalenceTuple *eqTuple, int *memberAdd, int *isSenAdd, int noOfMemberAdd, int noOfSenAdd)
{
	int noOfMember;

	int *newMember;
	int *newIsSen;

	noOfMember = eqTuple->noOfMember;

	if (noOfMemberAdd > 0)
	{
		if (noOfMember == 0)
		{
			newMember = (int *) malloc(sizeof(int)*noOfMemberAdd);
			newIsSen = (int *) malloc(sizeof(int)*noOfMemberAdd);
		}
		else
		{
			newMember = (int *) realloc(eqTuple->member, sizeof(int)*(noOfMember+noOfMemberAdd));
			newIsSen = (int *) realloc(eqTuple->isSen, sizeof(int)*(noOfMember+noOfMemberAdd));
		}

		memcpy(&(newMember[noOfMember]), memberAdd, sizeof(int)*noOfMemberAdd);
		memcpy(&(newIsSen[noOfMember]), isSenAdd, sizeof(int)*noOfMemberAdd);

		eqTuple->noOfMember += noOfMemberAdd;
		eqTuple->noOfSen += noOfSenAdd;
		eqTuple->member = newMember;
		eqTuple->isSen = newIsSen;
	}
}

void top_moveMemberSen_One(equivalenceTuple *fromEqTuple, equivalenceTuple *toEqTuple, int fromIndex)
{
	int memberNo, isSen;

	// remove from fromEqTuple
	top_removeMemberSen_One(fromEqTuple, fromIndex, &memberNo, &isSen);

	// insert to toEqTuple
	top_insertMemberSen_One(toEqTuple, memberNo, isSen);
}


void top_moveMemberSen_All(equivalenceTuple *fromEqTuple, equivalenceTuple *toEqTuple)
{
	int *member;
	int *isSen;
	int noOfMember, noOfSen;

	// remove from fromEqTuple
	top_removeMemberSen_All(fromEqTuple, &member, &isSen, &noOfMember, &noOfSen);

	// insert to toEqTuple
	top_insertMemberSen_All(toEqTuple, member, isSen, noOfMember, noOfSen);

	// 
	if (fromEqTuple->noOfMember > 0)
	{
		free(fromEqTuple->member);
		free(fromEqTuple->isSen);
	}
	fromEqTuple->noOfMember = 0;
	fromEqTuple->noOfSen = 0;
	// content has not been freed yet
	
}


// assume n_s > ceiling(n*alpha)
int top_findNoOfNonSenRequire(equivalenceTuple *eqTuple, double alpha)
{
	int returnValue;

	int noOfSen, noOfMember;

	

	noOfSen = eqTuple->noOfSen;
	noOfMember = eqTuple->noOfMember;

	//returnValue = 0;
	returnValue = (int) ((noOfSen-1)/alpha-noOfMember);
	while (noOfSen > ceiling((noOfMember+returnValue)*alpha))
	{
		returnValue++;
	}

	return returnValue;
}

int top_findNoOfSenRequire(equivalenceTuple *eqTuple, configure *conf)
{
	int returnValue;
	double alpha;

	int noOfSen, noOfMember;

	alpha = conf->alpha;

	noOfSen = eqTuple->noOfSen;
	noOfMember = eqTuple->noOfMember;

	if (alpha < 1.0)
	{
		//returnValue = 0;
		returnValue = ceiling((noOfMember*alpha+1-noOfSen)/(1-alpha));
		while (noOfSen+returnValue > ceiling((noOfMember+returnValue)*alpha))
		{
			returnValue--;
		}
	}
	else
	{
		// alpha == 1.0
		returnValue = conf->noOfTuple;
	}

	return returnValue;
}

int top_findMinNoOfMemberSatisfyK(equivalenceTuple *eqTuple, configure *conf)
{
	int returnValue;
	double alpha, K;

	int noOfSen, noOfMember;

	alpha = conf->alpha;
	K = conf->K;

	noOfSen = eqTuple->noOfSen;
	noOfMember = eqTuple->noOfMember;

	returnValue = (int)((noOfSen-1)/alpha);
	while (noOfSen > ceiling(returnValue*alpha))
	{
		returnValue++;
	}

	// returnValue should be larger than K (implicitly, noOfMember >= K)
	while (returnValue < K)
	{
		returnValue++;
	}
	

	return returnValue;
}

int findMax(int no1, int no2)
{
	if (no1 > no2)
	{
		return no1;
	}
	else
	{
		return no2;
	}
}

int top_findMinNoOfNonSen_forK(equivalenceTuple *eqTuple, configure *conf)
{
	int returnValue;

	double alpha;
	int noOfSen, noOfMember;

	alpha = conf->alpha;

	noOfSen = eqTuple->noOfSen;
	noOfMember = eqTuple->noOfMember;

	returnValue = (int) ((noOfSen-alpha)/alpha-noOfMember);

	returnValue = findMax(returnValue, 1);

	return returnValue;
}

void top_moveNonSenUp_One(equivalenceTuple *parentEqTuple, equivalenceTuple *childEqTuple, int noOfNonSenUp)
{
	int noOfMemberChild;
	int *isSenChild;

	int *whichMove;

	int i;
	int count;

	noOfMemberChild = childEqTuple->noOfMember;
	isSenChild = childEqTuple->isSen;

	whichMove = (int *) malloc(sizeof(int)*noOfMemberChild);
	memset(whichMove, 0, sizeof(int)*noOfMemberChild);

	count = 0;
	for (i = 0; i < noOfMemberChild; i++)
	{
		if (isSenChild[i] == 0)
		{
			whichMove[i] = 1;
			count++;

			if (count >= noOfNonSenUp)
			{
				break;
			}
		}
	}

	// move
	for (i = noOfMemberChild-1; i >= 0; i--)
	{
		if (whichMove[i] == 1)
		{
			top_moveMemberSen_One(childEqTuple, parentEqTuple, i);
		}
	}

	free(whichMove);
}


void top_moveSenUp_One(equivalenceTuple *parentEqTuple, equivalenceTuple *childEqTuple, int noOfNonSenUp)
{
	int noOfMemberChild;
	int *isSenChild;

	int *whichMove;

	int i;
	int count;

	noOfMemberChild = childEqTuple->noOfMember;
	isSenChild = childEqTuple->isSen;

	whichMove = (int *) malloc(sizeof(int)*noOfMemberChild);
	memset(whichMove, 0, sizeof(int)*noOfMemberChild);

	count = 0;
	for (i = 0; i < noOfMemberChild; i++)
	{
		if (isSenChild[i] == 1)
		{
			whichMove[i] = 1;
			count++;

			if (count >= noOfNonSenUp)
			{
				break;
			}
		}
	}

	// move
	for (i = noOfMemberChild-1; i >= 0; i--)
	{
		if (whichMove[i] == 1)
		{
			top_moveMemberSen_One(childEqTuple, parentEqTuple, i);
		}
	}

	free(whichMove);
}

void top_moveOneSatifiedUp(equivalenceTuple *parentEqTuple, equivalenceTuple **childEqTuple, int *isSatisfy, int noOfChild)
{
	int i;

	for (i = noOfChild-1; i >= 0; i--)
	{
		if ((isSatisfy[i] == 1) && (childEqTuple[i]->noOfMember > 0))
		{
			top_moveMemberSen_All(childEqTuple[i], parentEqTuple);
			isSatisfy[i] = 0;
			break;
		}
	}
}

void top_moveNonSenUp(equivalenceTuple *parentEqTuple, equivalenceTuple **childEqTuple, int *isSatisfy, int noOfChild, int noOfNonSenRequire, configure *conf)
{
	int i;

	int K;

	int minNoOfMember;
	int *noOfNonSenMove;
	int totalNoOfNonSenMove;

	int *whichMove;
	int lastMoveIndex;

	int noOfRealMove;
	int noOfRemain;

	equivalenceTuple *oneChild;

	K = conf->K;

	whichMove = (int *) malloc(sizeof(int)*noOfChild);
	memset(whichMove, 0, sizeof(int)*noOfChild);

	noOfNonSenMove = (int *) malloc(sizeof(int)*noOfChild);
	memset(noOfNonSenMove, 0, sizeof(int)*noOfChild);

	// for each satisfied child
	// find total no. of non sen move
	totalNoOfNonSenMove = 0;
	for (i = 0; i < noOfChild; i++)
	{
		if (isSatisfy[i] == 1)
		{
			oneChild = childEqTuple[i];

			// find the min. no. of member 
			minNoOfMember = top_findMinNoOfMemberSatisfyK(oneChild, conf);

			// find the no. of non sen move
			noOfNonSenMove[i] = oneChild->noOfMember - minNoOfMember;

			if (noOfNonSenMove[i] > 0)
			{
				totalNoOfNonSenMove += noOfNonSenMove[i];
				whichMove[i] = 1;
				lastMoveIndex = i;
			}

			if (totalNoOfNonSenMove >= noOfNonSenRequire)
			{
				break;
			}
		}
	}

	// 
	if (totalNoOfNonSenMove >= noOfNonSenRequire)
	{
		// move noOfNonSenRequire up 
		noOfRemain = noOfNonSenRequire;
		for (i = 0; i < noOfChild; i++)
		{
			if (whichMove[i] == 1)
			{
				if (i != lastMoveIndex)
				{
					// move noOfNonSenMove
					noOfRealMove = noOfNonSenMove[i];
					noOfRemain -= noOfRealMove;
				}
				else
				{
					// move noOfNonSenMove-noOfRemain;
					//noOfRealMove = noOfNonSenMove[i]-noOfRemain;
					noOfRealMove = noOfRemain;
				}
				
				top_moveNonSenUp_One(parentEqTuple, childEqTuple[i], noOfRealMove);
			}
		}

		// 
		if (parentEqTuple->noOfMember < K)
		{
			// move one satisfied branch up
			//top_moveOneSatifiedUp(parentEqTuple, childEqTuple, isSatisfy, noOfChild);

			// process insufficient K
			top_processInsuffK(parentEqTuple, childEqTuple, isSatisfy, noOfChild, conf);
		}
		else
		{
			// do nothing
		}
		
	}
	else
	{
		// move all branches up to the parent
		for (i = 0; i < noOfChild; i++)
		{
			if (isSatisfy[i] == 1)
			{
				top_moveMemberSen_All(childEqTuple[i], parentEqTuple);
				isSatisfy[i] = 0;
			}
		}
	}

	free(whichMove);
	free(noOfNonSenMove);
}

void top_moveSenUp(equivalenceTuple *parentEqTuple, equivalenceTuple **childEqTuple, int *isSatisfy, int noOfChild, int noOfSenRequire, configure *conf)
{
	int i;

	int K;

	int *noOfSenMove;
	int totalNoOfSenMove;

	int *whichMove;
	int lastMoveIndex;

	int noOfRealMove;
	int noOfRemain;

	equivalenceTuple *oneChild;

	int noOfNonSenRequire;

	K = conf->K;

	whichMove = (int *) malloc(sizeof(int)*noOfChild);
	memset(whichMove, 0, sizeof(int)*noOfChild);

	noOfSenMove = (int *) malloc(sizeof(int)*noOfChild);
	memset(noOfSenMove, 0, sizeof(int)*noOfChild);

	// for each satisfied child
	// find total no. of sen move
	totalNoOfSenMove = 0;
	for (i = 0; i < noOfChild; i++)
	{
		if (isSatisfy[i] == 1)
		{
			oneChild = childEqTuple[i];

			// find the no. of sen move  (oneChild->noOfmember >= K due to isSatisfy[i] = 1)
			noOfSenMove[i] = findMin(oneChild->noOfSen, oneChild->noOfMember-K);

			if (noOfSenMove[i] > 0)
			{
				totalNoOfSenMove += noOfSenMove[i];
				whichMove[i] = 1;
				lastMoveIndex = i;
			}

			if (totalNoOfSenMove >= noOfSenRequire)
			{
				break;
			}
		}
	}

	// 
	if (totalNoOfSenMove >= noOfSenRequire)
	{
		// move noOfSenRequire up 
		noOfRemain = noOfSenRequire;
		
		
	}
	else
	{
		// move totalNoOfSenMove
		noOfRemain = totalNoOfSenMove;
	}

	if (noOfRemain != 0)
	{

		for (i = 0; i < noOfChild; i++)
		{
			if (whichMove[i] == 1)
			{
				if (i != lastMoveIndex)
				{
					// move noOfNonSenMove
					noOfRealMove = noOfSenMove[i];
					noOfRemain -= noOfRealMove;
				}
				else
				{
					// move noOfNonSenMove-noOfRemain;
					//noOfRealMove = noOfSenMove[i]-noOfRemain;
					noOfRealMove = noOfRemain;
				}
					
				top_moveSenUp_One(parentEqTuple, childEqTuple[i], noOfRealMove);
			}
		}
	}
	else
	{
		noOfNonSenRequire = findMax(1, K-parentEqTuple->noOfMember);
		top_moveNonSenUp(parentEqTuple, childEqTuple, isSatisfy, noOfChild, noOfNonSenRequire, conf);
	}

	// 
	if (parentEqTuple->noOfMember < K)
	{
		// process insufficient K
		top_processInsuffK(parentEqTuple, childEqTuple, isSatisfy, noOfChild, conf);
	}
	else
	{
		// do nothing
		// because the paraent has already satisified the alpha constraint
	}

	free(whichMove);
	free(noOfSenMove);
}


void top_processInsuffK(equivalenceTuple *parentEqTuple, equivalenceTuple **childEqTuple, int *isSatisfy, int noOfChild, configure *conf)
{
	int noOfMember;
	int noOfSen;

	double alpha;

	int noOfNonSenRequire, noOfSenRequire;

	alpha = conf->alpha;

	noOfMember = parentEqTuple->noOfMember;
	noOfSen = parentEqTuple->noOfSen;

	if (noOfSen > ceiling(noOfMember*alpha))
	{
		// find noOfNonSenRequire
		noOfNonSenRequire = top_findNoOfNonSenRequire(parentEqTuple, alpha);

		// move non sen up
		top_moveNonSenUp(parentEqTuple, childEqTuple, isSatisfy, noOfChild, noOfNonSenRequire, conf);
	}
	else
	{
		// find noOfSenRequire
		noOfSenRequire = top_findNoOfSenRequire(parentEqTuple, conf);

		// newly added
		noOfSenRequire = findMin(noOfSenRequire, conf->K-noOfMember);

		if (noOfSenRequire > 0)
		{
			// move sen. up
			top_moveSenUp(parentEqTuple, childEqTuple, isSatisfy, noOfChild, noOfSenRequire, conf);
		}
		else
		{
			// move one satisfied branch up
			//top_moveOneSatifiedUp(parentEqTuple, childEqTuple, isSatisfy, noOfChild);

			// move one non sen up
			noOfNonSenRequire = top_findMinNoOfNonSen_forK(parentEqTuple, conf);
			
			// newly added
			noOfNonSenRequire = findMin(noOfNonSenRequire, conf->K-noOfMember);

			top_moveNonSenUp(parentEqTuple, childEqTuple, isSatisfy, noOfChild, noOfNonSenRequire, conf);

			if (parentEqTuple->noOfMember < conf->K)
			{
				// process insuff. K
				top_processInsuffK(parentEqTuple, childEqTuple, isSatisfy, noOfChild, conf);
			}
			else
			{
				// do nothing
				// due to enough for alpha satisfaction
			}
		}
	}
}


equivalenceTuple **createBranch(dimension *dim, int noOfDim, int attrNo, int noOfBranch, int targetLevel)
{
	equivalenceTuple **returnValue;
	int i;

	dimension *newDim;
	dimension *oneDim;

	returnValue = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*noOfBranch);
	for (i = 0; i < noOfBranch; i++)
	{
		returnValue[i] = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
		memset(returnValue[i], 0, sizeof(equivalenceTuple));

		newDim = (dimension *) malloc(sizeof(dimension)*noOfDim);
		memcpy(newDim, dim, sizeof(dimension)*noOfDim);

		oneDim = &(newDim[attrNo]);
		oneDim->level = targetLevel;
		oneDim->value = i;

		returnValue[i]->content = newDim;
	}
	
	return returnValue;
}


int top_findGroupNo(data *dataSet, int memberNo, int attrNo, generalizedLevelTable *skipGenLevelTable)
{
	int returnValue;

	dimension *dim;

	tuple *dataTuple;

	dataTuple = dataSet->tupleList;

	dim = (dimension *) malloc(sizeof(dimension));
			
	// find group no.
	//memberNo = member[i];

	dim->level = 0;
	dim->value = dataTuple[memberNo].content[attrNo].value;

	generalizeDimension(dim, skipGenLevelTable);

	returnValue = dim->value;

	free(dim);

	return returnValue;
}

// target index should not be equal to the highest level
equivalenceTuple **specializeEqTupleSkip(equivalenceTuple *parentEqTuple, int attrNo, configure *conf, generalizedAllTable *genAllTable, data *dataSet, int *noOfChild)
{
	equivalenceTuple **returnValue;
	int i, j;

	int noOfDim;
	int genBottomLevel;

	int targetLevel;

	//equivalenceTuple **eqTuple;
	//equivalenceTuple *eqOne;

	int bottomValue, topValue, topLevel;

	int memberNo;
	tuple *dataTuple;

	dimension *dim;

	int *member;		

	int noOfBranch;
	int noOfMember;

	//tuple *dataTuple;

	int genBottomLevel_temp;
	generalizedLevelTable *genLevelTable_temp;

	int groupNo;

	generalizedDimTable *genDimTable;
	generalizedLevelTable *genLevelTable;

	generalizedLevelTable *skipGenLevelTable;

	noOfDim = conf->noOfDim;

	genDimTable = &(genAllTable->genDimTable[attrNo]);

	//eqTuple = (equivalenceTuple **) eqClass->eqClass; 

	targetLevel = parentEqTuple->content[attrNo].level-1;

	noOfDim = conf->noOfDim;

	member = parentEqTuple->member;
	
	dataTuple = dataSet->tupleList;

	//if (eqClass->noOfEqClass > 0)
	if ((parentEqTuple->noOfMember > 0) && (targetLevel >= 0))
	{
		if (targetLevel == 0)
		{
			// find no of branch
			genBottomLevel = targetLevel;
			genLevelTable = &(genDimTable->gen[genBottomLevel]);
			noOfBranch = genLevelTable->noOfPoss;

			// create noOfBranch eq. class
			returnValue = createBranch(parentEqTuple->content, noOfDim, attrNo, noOfBranch, targetLevel);

			// 
			noOfMember = parentEqTuple->noOfMember;
			for (i = noOfMember-1; i >= 0; i--)
			{
				// find group no
				member = parentEqTuple->member;
				memberNo = member[i];
				//groupNo = top_findGroupNo(dataSet, memberNo, attrNo, skipGenLevelTable);
				groupNo = dataTuple[memberNo].content[attrNo].value;
				
				// move member from parent to child
				top_moveMemberSen_One(parentEqTuple, returnValue[groupNo], i);
			}

			(*noOfChild) = noOfBranch;
		}
		else
		{
			//genBottomLevel = eqTuple[0]->content[attrNo].level;
			//genLevelTable = &(genDimTable->gen[genBottomLevel]);
			genBottomLevel = 0;
			genLevelTable = &(genDimTable->gen[genBottomLevel]);
			

			// generate a skipGenLevelTable
			skipGenLevelTable = (generalizedLevelTable *) malloc(sizeof(generalizedLevelTable));
			//skipGenLevelTable->noOfPoss = genLevelTable->noOfPoss;
			skipGenLevelTable->noOfPoss = 0;
			skipGenLevelTable->gen = (generalizedPair *) malloc(sizeof(generalizedPair)*genLevelTable->noOfPoss);

			dim = (dimension *) malloc(sizeof(dimension));
			for (i = 0; i < genLevelTable->noOfPoss; i++)
			{	
				dim->level = 0;
				dim->value = i;

				// generalize up to targetLevel
				for (j = 0; j < targetLevel; j++)
				{
					genBottomLevel_temp = j;
					genLevelTable_temp = &(genDimTable->gen[genBottomLevel_temp]);

					// generalize up one level
					generalizeDimension(dim, genLevelTable_temp);
				}

				bottomValue = i;
				topLevel = targetLevel;
				topValue = dim->value;

				insertGeneralizedLevelTable(skipGenLevelTable, bottomValue, topLevel, topValue);
			}
			free(dim);

			// find no of branch
			genBottomLevel = targetLevel;
			genLevelTable = &(genDimTable->gen[genBottomLevel]);
			noOfBranch = genLevelTable->noOfPoss;

			// create noOfBranch eq. class
			returnValue = createBranch(parentEqTuple->content, noOfDim, attrNo, noOfBranch, targetLevel);

			//
			noOfMember = parentEqTuple->noOfMember;
			for (i = noOfMember-1; i >= 0; i--)
			{
				// find group no
				member = parentEqTuple->member;
				memberNo = member[i];
				groupNo = top_findGroupNo(dataSet, memberNo, attrNo, skipGenLevelTable);

				// move member from parent to child
				top_moveMemberSen_One(parentEqTuple, returnValue[groupNo], i);
			}

			// free
			free(skipGenLevelTable->gen);
			free(skipGenLevelTable);

			(*noOfChild) = noOfBranch;
		}
	}
	else
	{
		// do nothing
		returnValue = NULL;
		(*noOfChild) = 0;
	}

	return returnValue;
}

int *top_createSatisfyAndMoveBack(equivalenceTuple *parentEqTuple, equivalenceTuple **childEqTuple, int noOfChild, configure *conf)
{
	int *returnValue;

	double alpha;
	int K;

	equivalenceTuple *oneChildEqTuple;

	int i;

	returnValue = (int *) malloc(sizeof(int)*noOfChild);
	memset(returnValue, 0, sizeof(int)*noOfChild);

	K = conf->K;
	alpha = conf->alpha;

	// find isSatisfy
	for (i = 0; i < noOfChild; i++)
	{
		oneChildEqTuple = childEqTuple[i];
		if ((oneChildEqTuple->noOfMember >= K) && (oneChildEqTuple->noOfSen <= ceiling(oneChildEqTuple->noOfMember*alpha)))
		{
			// satisfy
			returnValue[i] = 1;
		}
		else
		{
			// not satisfy
			
			// need to move back
			top_moveMemberSen_All(oneChildEqTuple, parentEqTuple);
		}
	}

	return returnValue;
}

equivalenceTuple **expandValidEqTuple(equivalenceTuple *parentEqTuple, int attrNo, configure *conf, generalizedAllTable *genAllTable, data *dataSet, int *noOfChild, int **outIsSatisfy)
{
	equivalenceTuple **returnValue;
	int *isSatisfy;

	int noOfMember, noOfSen;

	double alpha;
	int K;

	int noOfNonSenRequire;

	alpha = conf->alpha;
	K = conf->K;

	// naively special all members
	returnValue = specializeEqTupleSkip(parentEqTuple, attrNo, conf, genAllTable, dataSet, noOfChild);

	// create isSatisfy
	isSatisfy = top_createSatisfyAndMoveBack(parentEqTuple, returnValue, (*noOfChild), conf);

	noOfMember = parentEqTuple->noOfMember;
	noOfSen = parentEqTuple->noOfSen;
	if (noOfMember == 0)
	{
		// do nothing
	}
	else
	{
		if (noOfSen > ceiling(noOfMember*alpha))
		{
			noOfNonSenRequire = top_findNoOfNonSenRequire(parentEqTuple, alpha);
			top_moveNonSenUp(parentEqTuple, returnValue, isSatisfy, (*noOfChild), noOfNonSenRequire, conf);
		}
		else
		{
			if (noOfMember < K)
			{
				top_processInsuffK(parentEqTuple, returnValue, isSatisfy, (*noOfChild), conf);
			}
			else
			{
				// do nothing
			}
		}
	}

	//free(isSatisfy);
	(*outIsSatisfy) = isSatisfy;

	return returnValue;

	
}

void top_calculateNoOfSatisfyTupleAndNoOfSatisfyBranch(equivalenceTuple *parentEqTuple, equivalenceTuple **childEqTuple, int noOfChild, int *isSatisfy, int *noOfSatisfyTuple, int *noOfSatisfyBranch)
{
	int i;

	equivalenceTuple *oneChildEqTuple;

	(*noOfSatisfyTuple) = 0;
	(*noOfSatisfyBranch) = 0;
	for (i = 0; i < noOfChild; i++)
	{
		oneChildEqTuple = childEqTuple[i];
		if ((isSatisfy[i] == 1) && (oneChildEqTuple->member > 0))
		{
			(*noOfSatisfyTuple) += oneChildEqTuple->noOfMember;
			(*noOfSatisfyBranch)++;
		}
	}
}


// -1: cannot find best index
int top_findBestAttrbuteForSpecialization(equivalenceTuple **parentEqTuple, equivalenceTuple ***childEqTuple, int *noOfChild, int **isSatisfy, configure *conf)
{
	int *noOfSatisfyTuple;
	int *noOfSatisfyBranch;

	int maxNoOfTuple, maxNoOfBranch;
	int bestIndex;

	int noOfDim;

	int i;

	bestIndex = -1;

	noOfDim = conf->noOfDim-1;

	noOfSatisfyTuple = (int *) malloc(sizeof(int)*noOfDim);
	noOfSatisfyBranch = (int *) malloc(sizeof(int)*noOfDim);

	// calculate noOfSatisfyTuple and noOfSatisfyBranch
	for (i = 0; i < noOfDim; i++)
	{
		top_calculateNoOfSatisfyTupleAndNoOfSatisfyBranch(parentEqTuple[i], childEqTuple[i], noOfChild[i], isSatisfy[i], &(noOfSatisfyTuple[i]), &(noOfSatisfyBranch[i]));
	}

	// find the best attribute

	// find the maxNoOfTuple
	// based on no. of tuples
	maxNoOfTuple = 0;
	for (i = 0; i < noOfDim; i++)
	{
		if (noOfSatisfyTuple[i] > maxNoOfTuple)
		{
			maxNoOfTuple = noOfSatisfyTuple[i];
		}
	}

	// find the maxNoOfBranch
	// based on no. of branches
	maxNoOfBranch = 0;
	for (i = 0; i < noOfDim; i++)
	{
		if (noOfSatisfyTuple[i] == maxNoOfTuple)
		{
			if (noOfSatisfyBranch[i] > maxNoOfBranch)
			{
				maxNoOfBranch = noOfSatisfyBranch[i];
				bestIndex = i;
			}
		}
	}

	// free
	free(noOfSatisfyTuple);
	free(noOfSatisfyBranch);

	return bestIndex;	
}

void moveBestSpecialization2FinalEqClass(equivalenceClass *finalEqClass, equivalenceTuple *parentEqTuple)
{
	if (parentEqTuple->noOfMember > 0)
	{
		insertEqTupleIntoEqClass(finalEqClass, parentEqTuple);
	}
}

equivalenceClass *top_generalize2TopLevel(data *dataSet, generalizedAllTable *genAllTable)
{
	equivalenceClass *returnValue;

	equivalenceTuple *oneEqTuple;

	int noOfTuple, noOfDim;

	tuple *dataTuple;	
	
	int *isSen;
	int noOfSen;
	
	dimension *content;

	generalizedDimTable *genDimTable;

	int totalNoOfLevel;

	int *member;

	int i;

	noOfTuple = dataSet->noOfTuple;
	noOfDim = dataSet->noOfDim;

	returnValue = (equivalenceClass *) malloc(sizeof(equivalenceClass));

	returnValue->eqClass = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *));
	returnValue->noOfEqClass = 1;

	oneEqTuple = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));

	returnValue->eqClass[0] = oneEqTuple;

	content = (dimension *) malloc(sizeof(dimension)*noOfDim);
	genDimTable = genAllTable->genDimTable;
	for (i = 0; i < noOfDim; i++)
	{
		totalNoOfLevel = genDimTable[i].noOfLevel;
		content[i].value = 0;
		content[i].level = totalNoOfLevel-1;
	}
	oneEqTuple->content = content;

	oneEqTuple->id = 0;
	oneEqTuple->noOfMember = noOfTuple;
	
	member = (int *) malloc(sizeof(int)*noOfTuple);
	isSen = (int *) malloc(sizeof(int)*noOfTuple);
	memset(isSen, 0, sizeof(int)*noOfTuple);

	dataTuple = dataSet->tupleList;
	noOfSen = 0;
	for (i = 0; i < noOfTuple; i++)
	{
		member[i] = i;

		// check the last sensitive attr.
		if (dataTuple[i].content[noOfDim-1].value == 1)
		{
			noOfSen++;
			isSen[i] = 1;
		}
	}

	oneEqTuple->member = member;
	oneEqTuple->isSen = isSen;
	oneEqTuple->noOfSen = noOfSen;

	return returnValue;
}

equivalenceTuple ****top_generateAllExpandValidEqTuple(equivalenceTuple ***parentEqTuple, int noOfParent, configure *conf, data *dataSet, generalizedAllTable *genAllTable, int ***noOfChild, int ****isSatisfy)
{
	int noOfDim;

	int attrNo;

	equivalenceTuple ****returnValue;

	int i, j;

	//int noOfEqTuple;
	//equivalenceTuple **eqTuple;
	//equivalenceTuple *parentEqTuple;

	int **temp_noOfChild;

	int ***temp_isSatisfy;

	//noOfEqTuple = eqClass->noOfEqClass;
	//eqTuple = eqClass->eqClass;
	
	noOfDim = conf->noOfDim-1;

	temp_noOfChild = (int **) malloc(sizeof(int *)*noOfParent);
	temp_isSatisfy = (int ***) malloc(sizeof(int **)*noOfParent);
	for (i = 0; i < noOfParent; i++)
	{
		temp_noOfChild[i] = (int *) malloc(sizeof(int)*noOfDim);
		memset(temp_noOfChild[i], 0, sizeof(int)*noOfDim);

		temp_isSatisfy[i] = (int **) malloc(sizeof(int *)*noOfDim);
		memset(temp_isSatisfy[i], 0, sizeof(int *)*noOfDim);
	}


	returnValue = (equivalenceTuple ****) malloc(sizeof(equivalenceTuple ***)*noOfParent);

	
	for (i = 0; i < noOfParent; i++)
	{
		//parentEqTuple = eqTuple[i];

		returnValue[i] = (equivalenceTuple ***) malloc(sizeof(equivalenceTuple **)*noOfDim);

		for (j = 0; j < noOfDim; j++)
		{
			attrNo = j;

			returnValue[i][attrNo] = expandValidEqTuple(parentEqTuple[i][j], attrNo, conf, genAllTable, dataSet, &(temp_noOfChild[i][attrNo]), &(temp_isSatisfy[i][attrNo]));
		}
	}

	(*noOfChild) = temp_noOfChild;
	(*isSatisfy) = temp_isSatisfy;


	return returnValue;

}


void top_processBestAttribute(equivalenceClass *finalEqClass, equivalenceClass *procEqClass, int noOfParentEqTuple, equivalenceTuple ***parentEqTuple, equivalenceTuple ****childEqTuple, int **noOfChild, int ***isSatisfy, configure *conf)
{
	int i, j, k;

	int bestAttrNo;

	int noOfDim;

	equivalenceTuple *oneEqTuple;

	for (i = 0; i < noOfParentEqTuple; i++)
	{
		bestAttrNo = top_findBestAttrbuteForSpecialization(parentEqTuple[i], childEqTuple[i], noOfChild[i], isSatisfy[i], conf);

		if (bestAttrNo != -1)
		{
			// choose bestAttrNo for the next step

			// move parentEqTuple[i][bestAttrNo] to finalEqClass
			oneEqTuple = parentEqTuple[i][bestAttrNo];
			if (oneEqTuple->noOfMember > 0)
			{
				insertEqTupleIntoEqClass(finalEqClass, oneEqTuple);
			}
			
			// move child to procEqClas
			for (j = 0; j < noOfChild[i][bestAttrNo]; j++)
			{
				oneEqTuple = childEqTuple[i][bestAttrNo][j];
				if (oneEqTuple->noOfMember > 0)
				{
					insertEqTupleIntoEqClass(procEqClass, oneEqTuple);
				}
			}
		}
		else
		{
			// no best attr. 
			// i.e. parent is the choice

			// move parentEqTuple[i][bestAttrNo] to finalEqClass
			//bestAttrNo = 0;
			if (parentEqTuple[i][0]->noOfMember > 0)
			{
				insertEqTupleIntoEqClass(finalEqClass, parentEqTuple[i][0]);
			}
		}

		// free
		noOfDim = conf->noOfDim-1;
		for (j = 0; j < noOfDim; j++)
		{
			if (bestAttrNo != j)
			{
				for (k = 0; k < noOfChild[i][j]; k++)
				{
					freeEquivalenceTuple(childEqTuple[i][j][k]);
					free(childEqTuple[i][j][k]);
				}
				free(childEqTuple[i][j]);
				free(isSatisfy[i][j]);

				free(parentEqTuple[i][j]);
			}
			else
			{
				for (k = 0; k < noOfChild[i][j]; k++)
				{
					//freeEquivalenceTuple(childEqTuple[i][j][k]);
					free(childEqTuple[i][j][k]);
				}
				free(childEqTuple[i][j]);
				free(isSatisfy[i][j]);

				free(parentEqTuple[i][j]);
			}
		}
		free(childEqTuple[i]);
		free(noOfChild[i]);
		free(isSatisfy[i]);
		free(parentEqTuple[i]);

	}
	//free(childEqTuple);
}

